/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef MMI_H_
#define MMI_H_

#include <digitalSTROM/dsuid.h>
#include "digitalSTROM/ds485.h"

#include "qp_port.h"

typedef enum {
    MMI_DS485_INITIALIZING,
    MMI_DS485_READY,
    MMI_DS485_JOINING
} MMI_DS485;

typedef enum {
    MMI_CONFIG_INVALID,
    MMI_CONFIG_OK
} MMI_Config;

/**
 * MMI dS485 event structure
 */
typedef struct MMI_DS485StateEvtTag {
    QEvent super;
    MMI_DS485 ds485;
} MMIDS485StateEvt;

/**
 * MMI configuration event structure
 */
typedef struct MMI_ConfigStateEvtTag {
    QEvent super;
    MMI_Config config;
} MMI_ConfigStateEvt;

typedef struct {
    QEvent super;
    dsuid_t dsuid;
} MMI_DS485DsuidRegisteredEvt;

typedef struct{
    QEvent super;
    ds485s_bus_state_t state;
} MMI_BusStateEvt;

void MMI_ctor(void);

extern QActive * const AO_MMI; /* "opaque" pointer to MMI AO */

#endif /* MMI_H_ */
